﻿Public Class Form1
    Private Declare Function MBegin Lib "pcltoimage.dll" () As Integer
    Private Declare Function MConvert Lib "pcltoimage.dll" (ByVal id As Integer, ByVal infile As String, ByVal outpath As String, ByVal filename As String) As Integer
    Private Declare Function MSetParam Lib "pcltoimage.dll" (ByVal id As Integer, ByVal imagetype As Integer, ByVal bitcount As Integer, ByVal quality As Integer, ByVal rotate As Integer, ByVal width As Integer, ByVal height As Integer, ByVal xdpi As Integer, ByVal ydpi As Integer, ByVal compression As Integer, ByVal multipage As Integer) As Integer
    Private Declare Function MEnd Lib "pcltoimage.dll" (ByVal id As Integer) As Integer


    Const IMAGE_FORMAT_BMP = 1
    Const IMAGE_FORMAT_EMF = 2
    Const IMAGE_FORMAT_WMF = 3
    Const IMAGE_FORMAT_JPG = 4
    Const IMAGE_FORMAT_PNG = 5
    Const IMAGE_FORMAT_GIF = 6
    Const IMAGE_FORMAT_TIF = 7
    Const IMAGE_FORMAT_PCX = 8
    Const IMAGE_FORMAT_TGA = 9
    Const IMAGE_FORMAT_JP2 = 10
    Const IMAGE_FORMAT_RAS = 11
    Const IMAGE_FORMAT_JPC = 12

    'The compression method in the generated TIFF file.
    Const COMPRESSION_NONE = 0
    Const COMPRESSION_LZW = 1
    Const COMPRESSION_JPEG = 2
    Const COMPRESSION_PACKBITS = 3
    Const COMPRESSION_CCITTG4 = 4
    Const COMPRESSION_CCITTG3 = 5
    Const COMPRESSION_RLE = 6


    Const BITCOUNT_1 = 1       'black/white( 1 bits )
    Const BITCOUNT_4G = 3      '16 color grayscale( 4 bits )
    Const BITCOUNT_4 = 4       '16 color( 4 bits )
    Const BITCOUNT_8G = 7      '256 color grayscale( 8 bits )
    Const BITCOUNT_8 = 8       '256 color( 8 bits )
    Const BITCOUNT_24 = 24     'True color( 24 bits )


    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim id As Integer
        Dim imagetype As Integer
        Dim bitcount As Integer
        Dim quality As Integer
        Dim rotate As Integer
        Dim width As Integer
        Dim height As Integer
        Dim xdpi As Integer
        Dim ydpi As Integer
        Dim compression As Integer
        Dim multipage As Integer

        id = MBegin()
        If (id > 0) Then
            imagetype = IMAGE_FORMAT_TIF
            bitcount = BITCOUNT_24
            quality = 75
            rotate = 0
            width = 0
            height = 0
            xdpi = 150
            ydpi = 150
            'only for tiff
            compression = COMPRESSION_LZW
            multipage = 1

            'Set Output image param
            MSetParam(id, imagetype, bitcount, quality, rotate, width, height, xdpi, ydpi, compression, multipage)

            'Convert to tiff file (multiple page)
            MConvert(id, "test.pcl", "", "multiple")

            MEnd(id)
        End If

        MsgBox("Convert finished!")
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Dim id As Integer
        Dim imagetype As Integer
        Dim bitcount As Integer
        Dim quality As Integer
        Dim rotate As Integer
        Dim width As Integer
        Dim height As Integer
        Dim xdpi As Integer
        Dim ydpi As Integer
        Dim compression As Integer
        Dim multipage As Integer

        id = MBegin()
        If (id > 0) Then
            imagetype = IMAGE_FORMAT_JPG
            bitcount = BITCOUNT_8G '256 color grayscale( 8 bits )
            quality = 85
            rotate = 90
            width = 1000
            height = 800
            xdpi = 200
            ydpi = 200

            'only for tiff
            compression = 0
            multipage = 0

            'Set Output image param
            MSetParam(id, imagetype, bitcount, quality, rotate, width, height, xdpi, ydpi, compression, multipage)

            'Convert to jpg file
            MConvert(id, "test.pcl", "path", "jpg")

            MEnd(id)
        End If

        MsgBox("Convert finished!")
    End Sub
End Class
